#!/bin/sh
#1 list of SUPPORTED_BLOCK_SIZE
#2 list of SUPPORTED_ERASE_BLOCK_SIZE
#3 list of SUPPORTED_END

if [ "${1}" = "" -o "${2}" = "" -o "${3}" = "" ] ; then
	echo "Invalid argument!"
	exit 1
fi

SUPPORTED_BLOCK_SIZE=$1
SUPPORTED_ERASE_BLOCK_SIZE=$2
SUPPORTED_END=$3

ROOTFS=buffalo_nand
IMG_DIR=images
IMG_BASE=buffalo_nand

echo "SUPPORTED_BLOCK_SIZE=${SUPPORTED_BLOCK_SIZE}"
echo "SUPPORTED_ERASE_BLOCK_SIZE=${SUPPORTED_ERASE_BLOCK_SIZE}"
echo "SUPPORTED_END=${SUPPORTED_END}"

if [ ! -d ${IMG_DIR} ] ; then
	mkdir ${IMG_DIR}
fi

if [ ! -d ${ROOTFS} ] ; then
	mkdir ${ROOTFS}/lost+found -p
else
	rm -rf ${ROOTFS}/*
	mkdir ${ROOTFS}/lost+found
fi

for BS in ${SUPPORTED_BLOCK_SIZE}
do
	for EBS in ${SUPPORTED_ERASE_BLOCK_SIZE}
	do
		
		for END in ${SUPPORTED_END}
		do
			case ${END} in 
			LE)
				END_OPT="-l"
				;;
			BE)
				END_OPT="-b"
				;;
			esac
				mkfs.jffs2 -r ${ROOTFS} -p -s ${BLOCK_SIZE} -e ${ERASE_BLOCK_SIZE} ${END_OPT} -n -o ${IMG_DIR}/${IMG_BASE}_${BS}_${EBS}_${END}.jffs2
		done
	done
done

. ./.config
IMAGE_DIR=`echo ${PREFIX_DIR}${IMG_DIR}|sed -e "s%//%/%"`
cat mkfs.jffs2.in |\
	sed -e "s%<<<---SUPPORTED_BLOCK_SIZE--->>>%${SUPPORTED_BLOCK_SIZE}%g" |\
	sed -e "s%<<<---SUPPORTED_ERASE_BLOCK_SIZE--->>>%${SUPPORTED_ERASE_BLOCK_SIZE}%g" |\
	sed -e "s%<<<---IMG_BASE_DIR--->>>%${IMAGE_DIR}%" |\
	sed -e "s%<<<---IMG_BASE_NAME--->>>%${IMG_BASE}%" > mkfs.jffs2
